## mupen64plus-input-sdl 2.5

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   Mupen64plus-input-sdl - Makefile                                      *
# *   Mupen64Plus homepage: http://code.google.com/p/mupen64plus/           *
# *   Copyright (C) 2007-2009 Richard Goedeken                              *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for SDL Input plugin in Mupen64plus

# detect operating system
UNAME ?= $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
  SO_EXTENSION = dylib
  SHARED = -bundle
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","OpenBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
  $(warning OS type "$(UNAME)" not officially supported.')
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
  OS = MINGW
  SO_EXTENSION = dll
  SHARED = -shared
  PIC = 0
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# detect system architecture, only if it matters for build flags
HOST_CPU ?= $(shell uname -m)
CPU := OTHER
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
    PIC ?= 0
  else
    ARCH_DETECTED := 64BITS
    PIC ?= 1
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
  PIC ?= 0
endif
ifeq ("$(CPU)","OTHER")
  PIC ?= 1
endif

# base CFLAGS, LDLIBS, and LDFLAGS
OPTFLAGS ?= -O3 -flto
WARNFLAGS ?= -Wall
CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src -D_GNU_SOURCE=1
LDFLAGS += $(SHARED)

# Since we are building a shared library, we must compile with -fPIC on some architectures
# On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
ifeq ($(PIC), 1)
  CFLAGS += -fPIC
else
  CFLAGS += -fno-PIC
endif

# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  CFLAGS += -m32
  LDFLAGS += -Wl,-m,elf_i386
endif

# set special flags per-system
ifeq ($(OS), FREEBSD)
  ifeq ($(ARCH_DETECTED), 64BITS_32)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
endif
ifeq ($(OS), LINUX)
  LDLIBS += -ldl
endif
ifeq ($(OS), OSX)
  #xcode-select has been around since XCode 3.0, i.e. OS X 10.5
  OSX_SDK_ROOT = $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs
  OSX_SDK_PATH = $(OSX_SDK_ROOT)/$(shell ls $(OSX_SDK_ROOT) | tail -1)

  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -arch x86_64 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
      LDLIBS += -ldl
    else
      CFLAGS += -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
      LDLIBS += -ldl -read_only_relocs suppress
    endif
  endif
endif

# test for presence of SDL
ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
  SDL_CONFIG = $(CROSS_COMPILE)sdl2-config
  ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
    SDL_CONFIG = $(CROSS_COMPILE)sdl-config
    ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
      $(error No SDL development libraries found!)
    else
      $(warning Using SDL 1.2 libraries)
    endif
  endif
  SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
  SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
endif
CFLAGS += $(SDL_CFLAGS)
LDLIBS += $(SDL_LDLIBS)

# set mupen64plus core API header path
ifneq ("$(APIDIR)","")
  CFLAGS += "-I$(APIDIR)"
else
  TRYDIR = ../../../mupen64plus-core/src/api
  ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
    CFLAGS += -I$(TRYDIR)
  else
    TRYDIR = /usr/local/include/mupen64plus
    ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
      CFLAGS += -I$(TRYDIR)
    else
      TRYDIR = /usr/include/mupen64plus
      ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
        CFLAGS += -I$(TRYDIR)
      else
        $(error Mupen64Plus API header files not found! Use makefile parameter APIDIR to force a location.)
      endif
    endif
  endif
endif

# reduced compile output when running make without V=1
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
    Q_CC = @echo '    CC  '$@;
    Q_LD = @echo '    LD  '$@;
endif
endif

# set base program pointers and flags
CC        = $(CROSS_COMPILE)gcc
CXX       = $(CROSS_COMPILE)g++
RM       ?= rm -f
INSTALL  ?= install
MKDIR ?= mkdir -p
COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.o = $(Q_LD)$(CC) $(CFLAGS) $(LDFLAGS) $(TARGET_ARCH)

# set special flags for given Makefile parameters
ifeq ($(DEBUG),1)
  CFLAGS += -g
  INSTALL_STRIP_FLAG ?= 
else
  ifneq ($(OS),OSX)
    INSTALL_STRIP_FLAG ?= -s
  endif
endif
ifeq ($(PLUGINDBG), 1)
  CFLAGS += -D_DEBUG
endif

# set installation options
ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif
ifeq ($(SHAREDIR),)
  SHAREDIR := $(PREFIX)/share/mupen64plus
endif
ifeq ($(LIBDIR),)
  LIBDIR := $(PREFIX)/lib
endif
ifeq ($(PLUGINDIR),)
  PLUGINDIR := $(LIBDIR)/mupen64plus
endif

SRCDIR = ../../src
OBJDIR = _obj$(POSTFIX)

# list of source files to compile
SOURCE = \
	$(SRCDIR)/plugin.c \
	$(SRCDIR)/autoconfig.c \
	$(SRCDIR)/sdl_key_converter.c \
	$(SRCDIR)/config.c

ifeq ($(OS),MINGW)
SOURCE += $(SRCDIR)/osal_dynamiclib_win32.c
else
SOURCE += $(SRCDIR)/osal_dynamiclib_unix.c
endif

# generate a list of object files build, make a temporary directory for them
OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
OBJDIRS = $(dir $(OBJECTS))
$(shell $(MKDIR) $(OBJDIRS))

# build targets
TARGET = mupen64plus-input-sdl$(POSTFIX).$(SO_EXTENSION)

targets:
	@echo "Mupen64Plus-input-sdl makefile. "
	@echo "  Targets:"
	@echo "    all           == Build Mupen64Plus SDL input plugin"
	@echo "    clean         == remove object files"
	@echo "    rebuild       == clean and re-build all"
	@echo "    install       == Install Mupen64Plus SDL input plugin"
	@echo "    uninstall     == Uninstall Mupen64Plus SDL input plugin"
	@echo "  Options:"
	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3 -flto)"
	@echo "    WARNFLAGS=flag == compiler warning levels (default: -Wall)"
	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
	@echo "  Install Options:"
	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
	@echo "    SHAREDIR=path == path to install shared data files (default: PREFIX/share/mupen64plus)"
	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
	@echo "  Debugging Options:"
	@echo "    DEBUG=1       == add debugging symbols"
	@echo "    PLUGINDBG=1   == print extra debugging information while running"
	@echo "    V=1           == show verbose compiler output"

all: $(TARGET)

install: $(TARGET)
	$(INSTALL) -d "$(DESTDIR)$(PLUGINDIR)"
	$(INSTALL) -m 0644 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(PLUGINDIR)"
	$(INSTALL) -d "$(DESTDIR)$(SHAREDIR)"
	$(INSTALL) -m 0644 "../../data/InputAutoCfg.ini" "$(DESTDIR)$(SHAREDIR)"

uninstall:
	$(RM) "$(DESTDIR)$(PLUGINDIR)/$(TARGET)"
	$(RM) "$(DESTDIR)$(SHAREDIR)/InputAutoCfg.ini"

clean:
	$(RM) -r $(OBJDIR) $(TARGET)

rebuild: clean all

# build dependency files
CFLAGS += -MD -MP
-include $(OBJECTS:.o=.d)

# standard build rules
$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(COMPILE.c) -o $@ $<

$(TARGET): $(OBJECTS)
	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@

.PHONY: all clean install uninstall targets

=== debian/changelog ===
mupen64plus-input-sdl (2.5-5) unstable; urgency=medium

  * debian/control
    - Automatically select correct Vcs-Git branch
    - Upgraded to policy 4.4.0, no changes required
    - Switch to debhelper 12
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Tue, 27 Aug 2019 23:28:05 +0200

mupen64plus-input-sdl (2.5-4) unstable; urgency=medium

  * debian/control
    - Change Vcs-Git to https://
    - update to debhelper 10
    - Move VCS-* to salsa.debian.org
  * Sort debian control files with `wrap-and-sort -abst`
  * Upgraded to policy 4.2.1
    - remove get-orig-source rule from debian/rules
  * debian/copyright:
    - Update copyright years
  * debian/rules
    - Remove ddeb migration conflict against pre-stretch package
    - Drop (now default) parameter --parallel for dch

 -- Sven Eckelmann <sven@narfation.org>  Thu, 18 Oct 2018 21:50:49 +0200

mupen64plus-input-sdl (2.5-3) unstable; urgency=medium

  * debian/control, debian/rules:
     - Drop mupen64plus-input-sdl-dbg in favor of -dbgsym package
  * Update copyright years in debian/copyright
  * debian/patches:
    - add-MayFlash-PC048-adapter-auto-config-from-Brandon-Bundy.patch
      Add auto-config for MayFlash PC048 adapter
    - new-Saitek-PLC-Cyborg-Force-Rumble-Pad-auto-config-from-P.patch
      Add auto-config for Saitek PLC Cyborg Force Rumble Pad controller
    - add-new-auto-config-section-for-Rock-Candy-gamepad-and-ne.patch
      Add auto-config for Rock Candy controller
    - add-OUYA-wireless-controller-auto-config-from-github-tick.patch
      Add auto-config for OUYA Game controller
    - add-another-huijia-auto-config-from-alecjw-on-github-tick.patch
      Add auto-config for HuiJia controller
    - added-specific-config-for-Logitech-F310-from-Marcus-Dean-.patch
      Add auto-config for Logitech F310 controller
    - Add-USB-Gamepad.patch,
      Add auto-config for USB Gamepad controller
    - fixes-for-Gasia-PS-Gamepad-from-Marcus-Dean-Adams-on-goog.patch,
      Fix auto-configuration for Gasia PS Gamepad
    - add-ShanWan-USB-autoconfig-from-Marco-on-google-group-lis.patch
      Add auto-config for ShanWan USB WirelessGamepad controller
    - Updated-Generic-X-Box-pad-to-conform-to-the-README.patch,
      Fix Generic XBox gamepad layout
    - Fixed-a-small-error-in-the-changed-section.patch,
      Fix newline in XBox gamepad layout
    - Fixed-Xbox-360-Wireless-Receiver-section.patch,
      Fix Xbox 360 Wireless Receiver layout

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 Jan 2016 12:47:51 +0100

mupen64plus-input-sdl (2.5-2) unstable; urgency=medium

  * debian/patches:
    - Add add-config-for-Sony-playstation-4-controller-and-rem.patch,
      Fix axis auto configuration in for Playstation 4 controllers
    - Add add-auto-config-for-Snakebyte-PS3-style-USB-controll.patch,
      Add auto-config for Snakebyte PS3-style USB controller
    - Add add-auto-config-for-Super-Joy-Box-13-Gamecube-USB-ad.patch,
      Add auto-config for Super Joy Box 13 Gamecube USB adapter
    - Add add-auto-config-for-Xiaomi-Bluetooth-Controller-from.patch,
      Add auto-config for Xiaomi Bluetooth Controller
    - Add add-auto-config-for-Logitech-F710-gamepad-by-me.patch,
      Add auto-config for Logitech F710 gamepad
    - Move patches to alternative DEP-3 format and manage them with gbp pq
  * debian/control:
    - Change Vcs-Browser to new alioth CGit URL
    - Move Vcs URLs from collab-maint to pkg-games
    - Update upstream URLs
    - Set Maintainer to Debian Games Team

 -- Sven Eckelmann <sven@narfation.org>  Thu, 26 Nov 2015 07:51:15 +0100

mupen64plus-input-sdl (2.5-1) unstable; urgency=medium

  * New Upstream Version
  * Upload to unstable
  * Upgraded to policy 3.9.6, no changes required
  * debian/copyright
    - Update years
    - Add new files
  * debian/patches
    - Remove upstream merged autoconfig_sony_dualshock4.patch

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 May 2015 16:14:00 +0200

mupen64plus-input-sdl (2.0+50+g83c33be-1) experimental; urgency=medium

  * New Upstream Snapshot from 83c33bee6921bae966cced52c8e4662a457918d9
  * Remove upstream merged autoconfig_acrux.patch,
    autoconfig_austgame_ps_converter.patch, autoconfig_bda_pro_ex.patch,
    autoconfig_ipequa.patch, autoconfig_jess_controller.patch,
    autoconfig_logitech_f310.patch, autoconfig_mayflash.patch,
    autoconfig_nintendo_wii_remote_pro.patch, autoconfig_retrolink_n64.patch,
    autoconfig_sidewinder_gamepad_pro.patch, autoconfig_szmy_gamepad3.patch,
    autoconfig_twin_gamepad.patch, autoconfig_twin_usb.patch,
    autoconfig_wiimote_classic.patch, autoconfig_xbox360.patch,
    autoconfig_xinput.patch, fallback_nomousegrab.patch,
    sdl2_forcefeedback.patch, sdl2_keysym.patch, sdl2_mousemode.patch

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Sep 2014 11:01:32 +0200

mupen64plus-input-sdl (2.0-4) unstable; urgency=medium

  * debian/watch:
    - Change upstream check from bitbucket to github
  * debian/copyright:
    - Change upstream source to github
  * debian/get-orig-source.sh
    - Change upstream repository to github
    - Change SCM from Mercurial to Git
  * Update copyright years in debian/copyright
  * Move keyring for signature verification to new debian/upstream/
  * debian/rules:
    - Use Largefile Support enabled C API
  * debian/patches:
    - Add autoconfig_acrux.patch, Add support for USB GAMEPAD 8116
    - Add autoconfig_austgame_ps_converter.patch, Add support for Austgame PS to
      USB convert cable
    - Add autoconfig_bda_pro_ex.patch, Add support for BDA Pro Ex
    - Add autoconfig_ipequa.patch, Add support for ipega media gamepad
      controller
    - Add autoconfig_logitech_f310.patch, Add support for Logitech Gamepad F310
    - Add autoconfig_mayflash.patch, Update deadzone/peak of Mayflash adapter
    - Add autoconfig_twin_usb.patch, Add support for Twin USB Gamepad


=== debian/control ===
Source: mupen64plus-input-sdl
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 4.4.0
Homepage: http://mupen64plus.org/
Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-input-sdl.git -b master
Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-input-sdl
Build-Depends:
 debhelper-compat (= 12),
 dpkg-dev (>= 1.16.1.1),
 libmupen64plus-dev (>= 1.99.5),
 libsdl2-dev,

Package: mupen64plus-input-sdl
Architecture: any-amd64 any-i386
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 mupen64plus-config-abi-2.2,
 mupen64plus-input-abi-2,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 mupen64plus-input,
Breaks:
 libmupen64plus2 (<< 2.0),
Description: sdl input device plugin for mupen64plus
 Input device plugin for mupen64plus which can use either keyboard or all by
 SDL supported input devices. All devices are autoconfigured using a
 database supplied with this package or through manual button mappings inside
 the local mupen64plus configuration.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildtools.mk

export PKG_CONFIG ?= pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG" SHAREDIR="/usr/share/games/mupen64plus/" SDL_CONFIG=sdl2-config

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix"

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_installchangelogs

=== debian/watch ===
version=3

opts="pgpsigurlmangle=s/$/.asc/" \
 https://github.com/mupen64plus/mupen64plus-input-sdl/releases \
	/mupen64plus/mupen64plus-input-sdl/releases/download/[^/]+/mupen64plus-input-sdl-src-(.*\d).tar.gz

## mupen64plus-input-sdl 2.5.9%2B55%2Bg2129e94

=== projects/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(mupen64plus-input-sdl)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(M64_APIDIR "${CMAKE_SOURCE_DIR}/../../../mupen64plus-core/src/api")

message("${CMAKE_SOURCE_DIR}/../../src/")

# State directories for modules and binaries
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMake)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMake/Find)

set(CMAKE_CC_FLAGS "-ffast-math -fno-strict-aliasing -fvisibility=hidden -D_GNU_SOURCE=1")

set(CMAKE_CXX_FLAGS "-pthread -fvisibility-inlines-hidden")

set(SRCS
  ${CMAKE_SOURCE_DIR}/../../src/autoconfig.c
  ${CMAKE_SOURCE_DIR}/../../src/config.c
  ${CMAKE_SOURCE_DIR}/../../src/plugin.c
  ${CMAKE_SOURCE_DIR}/../../src/sdl_key_converter.c
  )

if(WIN32)
  set(SRCS
    ${SRCS}
    ${CMAKE_SOURCE_DIR}/../../src/osal_dynamiclib_win32.c
    )
else()
  set(SRCS
    ${SRCS}
    ${CMAKE_SOURCE_DIR}/../../src/osal_dynamiclib_unix.c
    )
endif()

# Find dependencies
find_package(PNG REQUIRED)
if(NOT ZLIB_FOUND)
    include(ZLIB)
    message(FATAL_ERROR "Package zlib is required, but not found!")
endif(NOT ZLIB_FOUND)

find_package(PNG REQUIRED)
if(NOT PNG_FOUND)
    include(PNG)
    message(FATAL_ERROR "Package libpng is required, but not found!")
endif(NOT PNG_FOUND)

find_package(SDL2 REQUIRED)
if(NOT SDL2_FOUND)
    include(SDL2)
    message(FATAL_ERROR "Package SDL2 is required, but not found!")
endif(NOT SDL2_FOUND)

find_package(OpenGL REQUIRED)
if(NOT OpenGL_FOUND)
    message(FATAL_ERROR "Package OpenGL is required, but not found!")
endif(NOT OpenGL_FOUND)

find_package(Freetype REQUIRED)
if(NOT FREETYPE_FOUND)
    message(FATAL_ERROR "Package FreeType is required, but not found!")
endif(NOT FREETYPE_FOUND)

# Specify include directories
include_directories(
  ${PNG_INCLUDE_DIR}
  ${OpenGL_INCLUDE_DIR}
  ${SDL2_INCLUDE_DIR}
  ${FREETYPE_INCLUDE_DIR_ft2build}
  ${FREETYPE_INCLUDE_DIR_freetype2}
  ${M64_APIDIR}
  ${CMAKE_SOURCE_DIR}/../../src/
  )
# Create the binary
add_library(${CMAKE_PROJECT_NAME} SHARED ${SRCS})

# Link the libraries
# add_dependencies(${CMAKE_PROJECT_NAME} ${SDL2_LIBRARIES})

if(WIN32)
  target_link_libraries(${CMAKE_PROJECT_NAME}
    ${PNG_LIBRARY}
    ${OPENGL_LIBRARIES}
    ${SDL2_LIBRARY}
    ${ZLIB_LIBRARY}
    )
elseif(APPLE)
  target_link_libraries(${CMAKE_PROJECT_NAME}
    ${PNG_LIBRARY}
    ${OPENGL_LIBRARIES}
    ${SDL2_LIBRARY}
    ${ZLIB_LIBRARY}
    )
else()
  target_link_libraries(${CMAKE_PROJECT_NAME}
    ${PNG_LIBRARY}
    ${OPENGL_LIBRARIES}
    ${SDL2_LIBRARY}
    ${ZLIB_LIBRARY}
    ${FREETYPE_LIBRARIES}
    dl
    )
endif()

## mupen64plus-input-sdl 2.5.9+52+gac3b878

=== debian/changelog ===
mupen64plus-input-sdl (2.5.9+52+gac3b878-1) unstable; urgency=medium

  * New Upstream Snapshot from ac3b878cd14cf455cc40d94985ad1303383b1b7a
  * Upload to unstable

 -- Sven Eckelmann <sven@narfation.org>  Tue, 15 Nov 2022 15:44:26 +0100

mupen64plus-input-sdl (2.5.9-1) experimental; urgency=medium

  * New Upstream Version
  * debian/patches:
    - Add bump-API-version-to-2.1.0-to-fix-issue-79.patch, Update input API
      version to 2.1
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/control
    - Upgraded to policy 4.3.0, no changes required
    - Switch to debhelper 12
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Sat, 02 Mar 2019 20:17:00 +0100

mupen64plus-input-sdl (2.5-6) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.6.1, no changes required
    - Allow build without (fake)root
    - Switch default Vcs-Git branch to debian/unstable
    - Switch to debhelper compat 13
    - Remove versioned constraints unnecessary since buster
    - Use secure URI in Homepage field
  * debian/copyright
    - Update copyright years to 2022
  * Drop duplicated fields from upstream/metadata
  * Update debian/watch for format 4
  * Remove constraints unnecessary since buster (oldstable):
    + mupen64plus-input-sdl: Drop versioned constraint on libmupen64plus2 in
      Breaks.

 -- Sven Eckelmann <sven@narfation.org>  Mon, 14 Nov 2022 18:52:18 +0100

=== debian/control ===
Source: mupen64plus-input-sdl
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://mupen64plus.org/
Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-input-sdl.git -b debian/unstable
Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-input-sdl
Build-Depends:
 debhelper-compat (= 13),
 libmupen64plus-dev,
 libsdl2-dev,

Package: mupen64plus-input-sdl
Architecture: any-amd64 any-i386
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 mupen64plus-config-abi-2.2,
 mupen64plus-input-abi-2.1,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 mupen64plus-input,
Description: sdl input device plugin for mupen64plus
 Input device plugin for mupen64plus which can use either keyboard or all by
 SDL supported input devices. All devices are autoconfigured using a
 database supplied with this package or through manual button mappings inside
 the local mupen64plus configuration.

## mupen64plus-input-sdl 2.5.9+54+gaa18148

=== debian/changelog ===
mupen64plus-input-sdl (2.5.9+54+gaa18148-1) unstable; urgency=medium

  * New Upstream Snapshot from aa181483bfcac8901184f8c7590e4246eba5508b
  * debian/rules:
    - disallow compiler to drop code related to signed integer overflows during
      optimization
  * debian/control:
    - Upgraded to policy 4.6.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 31 Dec 2022 09:29:43 +0100

## mupen64plus-input-sdl 2.5.9+55+g2129e94

=== projects/unix/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 # *   Mupen64plus-input-sdl - Makefile                                      *
-# *   Mupen64Plus homepage: http://code.google.com/p/mupen64plus/           *
+# *   Mupen64Plus homepage: https://mupen64plus.org/                        *
 # *   Copyright (C) 2007-2009 Richard Goedeken                              *
 # *                                                                         *
 # *   This program is free software; you can redistribute it and/or modify  *
@@ -52,7 +52,6 @@
   OS = FREEBSD
   SO_EXTENSION = so
   SHARED = -shared
-  $(warning OS type "$(UNAME)" not officially supported.')
 endif
 ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
   OS = LINUX
@@ -66,7 +65,7 @@
   PIC = 0
 endif
 ifeq ("$(OS)","NONE")
-  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
+  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'https://github.com/mupen64plus/mupen64plus-core/issues')
 endif
 
 # detect system architecture, only if it matters for build flags
@@ -91,11 +90,15 @@
   PIC ?= 1
 endif
 
+SRCDIR = ../../src
+OBJDIR = _obj$(POSTFIX)
+
 # base CFLAGS, LDLIBS, and LDFLAGS
 OPTFLAGS ?= -O3 -flto
 WARNFLAGS ?= -Wall
-CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src -D_GNU_SOURCE=1
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I$(SRCDIR) -D_GNU_SOURCE=1
 LDFLAGS += $(SHARED)
+LDLIBS += -lm
 
 # Since we are building a shared library, we must compile with -fPIC on some architectures
 # On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
@@ -107,30 +110,38 @@
 
 # tweak flags for 32-bit build on 64-bit system
 ifeq ($(ARCH_DETECTED), 64BITS_32)
-  CFLAGS += -m32
-  LDFLAGS += -Wl,-m,elf_i386
+  ifeq ($(OS), FREEBSD)
+    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
+  endif
+  ifneq ($(OS), OSX)
+    ifeq ($(OS), MINGW)
+      LDFLAGS += -Wl,-m,i386pe
+    else
+      CFLAGS += -m32
+      LDFLAGS += -Wl,-m,elf_i386
+    endif
+  endif
+endif
+
+ifeq ($(ARCH_DETECTED), 64BITS)
+  ifeq ($(OS), MINGW)
+    LDFLAGS += -Wl,-m,i386pep
+  endif
 endif
 
 # set special flags per-system
-ifeq ($(OS), FREEBSD)
-  ifeq ($(ARCH_DETECTED), 64BITS_32)
-    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
-  endif
-endif
 ifeq ($(OS), LINUX)
   LDLIBS += -ldl
 endif
 ifeq ($(OS), OSX)
-  #xcode-select has been around since XCode 3.0, i.e. OS X 10.5
-  OSX_SDK_ROOT = $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs
-  OSX_SDK_PATH = $(OSX_SDK_ROOT)/$(shell ls $(OSX_SDK_ROOT) | tail -1)
+  OSX_SDK_PATH = $(shell xcrun --sdk macosx --show-sdk-path)
 
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -arch x86_64 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
+      CFLAGS += -arch x86_64 -mmacosx-version-min=10.6 -isysroot $(OSX_SDK_PATH)
       LDLIBS += -ldl
     else
-      CFLAGS += -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
+      CFLAGS += -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.6 -isysroot $(OSX_SDK_PATH)
       LDLIBS += -ldl -read_only_relocs suppress
     endif
   endif
@@ -197,6 +208,7 @@
   CFLAGS += -g
   INSTALL_STRIP_FLAG ?= 
 else
+  CFLAGS += -DNDEBUG
   ifneq ($(OS),OSX)
     INSTALL_STRIP_FLAG ?= -s
   endif
@@ -218,9 +230,6 @@
 ifeq ($(PLUGINDIR),)
   PLUGINDIR := $(LIBDIR)/mupen64plus
 endif
-
-SRCDIR = ../../src
-OBJDIR = _obj$(POSTFIX)
 
 # list of source files to compile
 SOURCE = \
@@ -275,7 +284,7 @@
 	$(INSTALL) -d "$(DESTDIR)$(PLUGINDIR)"
 	$(INSTALL) -m 0644 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(PLUGINDIR)"
 	$(INSTALL) -d "$(DESTDIR)$(SHAREDIR)"
-	$(INSTALL) -m 0644 "../../data/InputAutoCfg.ini" "$(DESTDIR)$(SHAREDIR)"
+	$(INSTALL) -m 0644 "$(SRCDIR)/../data/InputAutoCfg.ini" "$(DESTDIR)$(SHAREDIR)"
 
 uninstall:
 	$(RM) "$(DESTDIR)$(PLUGINDIR)/$(TARGET)"

=== debian/changelog ===
mupen64plus-input-sdl (2.5.9+55+g2129e94-1) unstable; urgency=medium

  * New Upstream Snapshot from 2129e942fdc2ee74d4d5f9c815dd204c45d9f4c1

 -- Sven Eckelmann <sven@narfation.org>  Wed, 01 Feb 2023 20:29:11 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://mupen64plus.org/
 Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-input-sdl.git -b debian/unstable

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,10 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 export DEB_CFLAGS_MAINT_APPEND=-flto
 export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
+
+# mupen64plus and its plugins sometimes use signed integer overflows
+# the compiler must not optimize them away due to their "undefined behavior"
+DEB_CFLAGS_MAINT_APPEND=-fno-aggressive-loop-optimizations -fno-strict-overflow
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

=== debian/watch ===
--- 
+++ 
@@ -1,4 +1,4 @@
-version=3
+version=4
 
 opts="pgpsigurlmangle=s/$/.asc/" \
  https://github.com/mupen64plus/mupen64plus-input-sdl/releases \

## mupen64plus-input-sdl 2.6.0

=== projects/unix/Makefile ===
--- 
+++ 
@@ -138,10 +138,10 @@
 
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -arch x86_64 -mmacosx-version-min=10.6 -isysroot $(OSX_SDK_PATH)
+      CFLAGS += -arch x86_64 -mmacosx-version-min=10.9 -isysroot $(OSX_SDK_PATH)
       LDLIBS += -ldl
     else
-      CFLAGS += -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.6 -isysroot $(OSX_SDK_PATH)
+      CFLAGS += -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.9 -isysroot $(OSX_SDK_PATH)
       LDLIBS += -ldl -read_only_relocs suppress
     endif
   endif

=== debian/changelog ===
mupen64plus-input-sdl (2.6.0-2) unstable; urgency=medium

  * debian/control:
    - Upgraded to policy 4.7.2, no changes required

 -- Sven Eckelmann <sven@narfation.org>  Sat, 01 Mar 2025 20:57:55 +0100

mupen64plus-input-sdl (2.6.0-1) unstable; urgency=medium

  * New Upstream Version
  * debian/rules:
    - Use DEB_BUILD_MAINT_OPTIONS to set lto flags
    - Use DEB_BUILD_MAINT_OPTIONS to set lfs flag
  * debian/watch:
    - Switch to api.github.com to check for releases

 -- Sven Eckelmann <sven@narfation.org>  Mon, 15 Jul 2024 10:27:31 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://mupen64plus.org/
 Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-input-sdl.git -b debian/unstable

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,7 @@
 -include /usr/share/dpkg/buildtools.mk
 
 export PKG_CONFIG ?= pkg-config
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
-export DEB_CFLAGS_MAINT_APPEND=-flto
-export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie optimize=+lto abi=+lfs
 
 # mupen64plus and its plugins sometimes use signed integer overflows
 # the compiler must not optimize them away due to their "undefined behavior"
